package ch.epfl.lara.rmf.exsolver;

object Test {

 def main(args: Array[String]) 
  {
   //sieve(from(2)) take 10 print
   //for (val t <- sieve(from(2))) Console.println(t)
   val testI = 1::2::3::Nil
   val testB = true::false::Nil
   val testA = 'A'::'B'::'C'::'D'::Nil
   val test2I = enumerateFromLists(testI::testI::Nil)
   val test2B = enumerateFromLists(testB::testB::Nil)
   val test2A = enumerateFromLists(testA::testA::Nil)
   val res = enumerateFromStreams[List[Any]](test2A::test2I::test2B::test2B::Nil)

   //test2 print
   for (val t <- res) Console.println(t)
  
  //enumerate(Stream.fromIterator(Iterator.range(1,4)),3,2) print
  }
 
 def streamOfList[A](list:List[Stream[A]]):Stream[List[A]] = 
   if(list exists (s => s.isEmpty)) Stream.empty else Stream.cons (list map (s => s.head), streamOfList(list map (s => s.tail))) 
     
   
   def enumerateFromLists[A](list:List[List[A]]):Stream[List[A]] =
   {
     val sizes = list map (s => s.size)
     val permSize = sizes reduceLeft ((i:Int,j:Int)=> i*j)
     val frequences = freqs(sizes,permSize).toList
     val repetitions = (sizes zip frequences) map (s => permSize / (s._1*s._2))
     
     val streams:List[Stream[A]] = (list zip (frequences zip repetitions)) map (p => repFreqStream[A](Stream.fromIterator(p._1.elements),p._2._1,p._2._2))
     
     streamOfList[A](streams)
   }
 
   def enumerateFromStreams[A](list:List[Stream[A]]):Stream[List[A]] = 
     {
     val sizes = list map (s => s.size)
     val permSize = sizes reduceLeft ((i:Int,j:Int)=> i*j)
     val frequences = freqs(sizes,permSize).toList
     val repetitions = (sizes zip frequences) map (s => permSize / (s._1*s._2))
     
     val streams:List[Stream[A]] = (list zip (frequences zip repetitions)) map (p => repFreqStream[A](p._1,p._2._1,p._2._2))
     
     streamOfList[A](streams)
   }
 
def freqs(sizes:List[Int], permSize:Int):Stream[Int] = sizes match
{
  case Nil => Stream.empty
  case first::rest => Stream.cons(permSize/first,freqs(rest,permSize/first))
}

 /*def listOfStream[A](list:List[List[A]]):List[Stream[A]] = list match
 {
   case first::rest => freqStream[A](first,list.size-1)::listOfStream[A](rest)
   case Nil => Nil
 }*/
   
 def repFreqStream[A](elems:Stream[A],freq:Int,rep:Int):Stream[A] = repStream[A](freqStream[A](elems,freq),rep)
 
 def freqStream[A](elems:Stream[A],freq:Int):Stream[A] = if(elems.isEmpty) Stream.empty
 else Stream.concat(buildStream[A](elems.head,freq),freqStream[A](elems.tail,freq))
 
 def repStream[A](elems:Stream[A],rep:Int):Stream[A] = 
   if(rep == 1) elems else
   Stream.concat(elems,repStream[A](elems,rep-1))
   
 def buildStream[A](elem:A, freq:Int):Stream[A] =  Stream.cons(elem,if (freq == 1) Stream.empty else buildStream[A](elem,freq-1))
}
