package ch.epfl.lara.rmf.exsolver;

case class Node[A](value:A, children: List[Node[A]])
{
  def leaves(path:List[A]):Stream[List[A]]=
    if(children.isEmpty) Stream.cons(value::path,Stream.empty)
    else 
    {
      def leaves1(todo:List[Node[A]]):Stream[List[A]] = todo match
      {
        case Nil => Stream.empty
        case x::xs => Stream.concat(x.leaves(value::path),leaves1(xs))
      }
      leaves1(children)
    }
}

case class Root[A](children: List[Node[A]])
{
  def leaves():Stream[List[A]]=
    if(children.isEmpty) Stream.cons(Nil,Stream.empty)
    else 
    {
      def leaves1(todo:List[Node[A]]):Stream[List[A]] = todo match
      {
        case Nil => Stream.empty
        case x::xs => Stream.concat(x.leaves(Nil),leaves1(xs))
      }
      leaves1(children)
    }
}

object Test2 {

  def list2stream[A] (xs: List[A]): Stream[A] = xs match {
  case Nil => Stream.empty
  case x :: xs1 => Stream.cons (x, list2stream (xs1))
  }

  def flatten[A](str: Stream[Stream[A]]):Stream[A] =
  {
    if(str.isEmpty)
    {
      Stream.empty
    }
    else
    {
      val inner = str.head;
      if(inner.isEmpty) flatten(str.tail)
      else Stream.cons(inner.head,flatten(Stream.cons(inner.tail,str.tail)))
    }
  }
                                               
  
  def visitTree[A](list: List[Node[A]]): Stream[List[A]]= Root(list).leaves
  
  def buildTree[A](list: List[List[A]]): List[Node[A]] = list match
  {
    case first::rest => first map (a => Node[A](a,buildTree[A](rest)))
    case Nil => Nil
  }
  
 def main(args: Array[String]) 
  {
   //sieve(from(2)) take 10 print
   //for (val t <- sieve(from(2))) Console.println(t)
   val testI = 1::2::3::Nil
   val testB = true::false::Nil
   val testA = 'A'::'B'::'C'::'D'::Nil
   val test2I = buildTree(testI::testI::Nil).toList
   val test2B = buildTree(testB::testB::Nil).toList
   val test2A = buildTree(testA::testA::Nil).toList
   val res = enumerateFromLists[Any](test2A::test2I::test2B::test2B::Nil)

   //test2 print
   for (val t <- res) Console.println(t)
  
  //enumerate(Stream.fromIterator(Iterator.range(1,4)),3,2) print
  }
 
 
   def enumerateFromLists[A](list:List[List[A]]):Stream[List[A]] =
   {
     visitTree(buildTree(list))
   }
 
 

}
