package ch.epfl.lara.rmf.interpretation;

/** Implements an iterable variable within domain 1 to d*/
class IterableVariable(domain:Int) extends Iterable {
  
  /** Current Value */
  var value = 1;

  def hasNext():Boolean = {        
    return value < domain;   
  }

  /** Go to the next iteration value */
  def next():Unit = {
    if (value < domain) {
      value += 1;
    }
  }
  
  /** Reset the Iterator to 1 */
  def reset():Unit = {
    value = 1;
  }
 
  /** Read the current value of the iterable variable */
  def getValue():Int = {
    return value;  
  }
  
  /** Randomize the state */
  def rand(rand:java.util.Random) = {
    value = rand.nextInt(domain) + 1;
  }
  
}
