package ch.epfl.lara.rmf.interpretation;

/**
 * SPEED constants
 */
object Speed {
    /** Definitions */
    var maxSpeed = 1.0;
    var defaultSpeed = 0.5;
    var minSpeed = 0.1;
    var deltaI = 0.5;
    var deltaD = 1.0;
}

/**
 * Speed of manipulation of indexes
 */  
class Speed {

  /** Actual Speed */
  var speed:Double = Speed.defaultSpeed;
  
  /** Increase the speed of modification at this place */  
  def increase() = {
    speed += Speed.deltaI;
    if (speed > Speed.maxSpeed) {
      speed = Speed.maxSpeed;
    }
  }
  
  /** Increase the speed of modification at this place */  
  def decrease() = {
    speed -= Speed.deltaD;
    if (speed < Speed.minSpeed) {
      speed = Speed.minSpeed;
    }
  }

  /** Should the associated variable change */
  def shouldChange(rand:java.util.Random):Boolean = {
    var r = rand.nextDouble();
    return speed > r;
  }
  
}
