package ch.epfl.lara.rmf.util
import scala.collection.mutable.HashMap

class Hypercube[P,T] extends (List[P] => Option[T]){
  
  val data: HashMap[P,Hypercube[P,T]] = new HashMap[P,Hypercube[P,T]]()
  var leaf: Option[T] = None
  
  def apply(params:List[P]):Option[T] = params match
  {
    case first::rest => data.get(first) match 
    {
      case Some(h)=>h(rest)
      case None => None
    }
    case Nil => leaf
  }
  
  def setValue(params:List[P], value:T):Unit = params match
  {
          case first::rest => data.get(first) match 
          {
            case Some(h)=>h.setValue(rest,value)
            case None => {
             val h = new Hypercube[P,T]()
             h.setValue(rest,value)
             data.update(first,h)
            }
          }
          case Nil => leaf=Some(value)
  }
  
  def getDefinedEntries:List[Pair[List[P],T]] = leaf match
  {  
    case Some(t) => Pair(Nil,t)::Nil
    case None => data.keys.toList flatMap((p:P) =>getDefinedEntries(p)) 
  }
  
  def getDefinedEntries(param:P):List[Pair[List[P],T]] =data.get(param) match
  {
          case Some(h) => prependParameter(param,h.getDefinedEntries)
          case None => throw new IllegalStateException()
  }
  
  def prependParameter(p:P,entries:List[Pair[List[P],T]]):List[Pair[List[P],T]] = entries map ( entry => prependParameter(p,entry))

  def prependParameter(p:P,entry:Pair[List[P],T]):Pair[List[P],T] = entry match
  {
    case Pair(params,t) => Pair(p::params,t)
  }
  
 def setValues(tuples: List[Pair[List[P],T]]): Unit = tuples match
 {
   case Pair(params,value)::rest =>
   {
     setValue(params,value)
     setValues(rest)
   }
   case Nil => 
 }
      
}
