package ch.epfl.lara.rmf.util
import scala.collection.mutable.HashMap

class SymbolTable[A] {
  val data: HashMap[String,A] = new HashMap[String,A]()
  
  def lookUp(name:String):A = data.get(name) match
  {
    case Some(sym) => sym;
    case None => throw new RuntimeException("Symbol " + name + " not found.");
  }
  
  def addSymbol(name:String, sym:A):Unit = data.update(name,sym)
}
